﻿Public Class SBPmain

    'Part 1: Variable tructures and variables on module level

    'Variable structure for handling pixel-coordinates
    Structure Coordinate
        Dim X As Short
        Dim Y As Short
    End Structure

    'Variable structure for handling pixel-polar coordinates
    Structure PolarCoordinate
        Dim Arc As Double
        Dim Radius As Double
        Dim Cosinus As Double
        Dim Sinus As Double
    End Structure

    'Variable structure for handling the bar and border size of a container
    Structure FrameSize
        Dim Border As Short
        Dim Bar As Short
    End Structure

    'Variable used bij SmartButton02
    Dim SmartText As String

    'Variable (object) used bij SmartButton03
    Dim BaseImage As Image

    'Part 2: Functions

    'Function calculates border- and barsize for rectangular objects
    Function ObjectFrame(OuterWidth As Integer, OuterHeight As Integer,
        InnerWidth As Integer, InnerHeight As Integer) As FrameSize
        'Internal function variable
        Dim Result As FrameSize

        'Calculating border and Bar size (=Result)
        Result.Border = (OuterWidth - InnerWidth) / 2
        Result.Bar = OuterHeight - InnerHeight - 2 * Result.Border

        'Returning function value
        Return Result

    End Function

    'Function calculates border- and barsize for forms
    Function Frame(Element As Form) As FrameSize
        'Internal function variable
        Dim Result As FrameSize

        'Calculating border and Bar size (=Result)
        Result.Border = (Element.Width - Element.ClientSize.Width) / 2
        Result.Bar = Element.Height - Element.ClientSize.Height - 2 * Result.Border

        'Returning function value
        Return Result

    End Function

    'Function calculates the distance (Radius) between two points
    Function CreateRadius(Point As Coordinate, Referencepoint As Coordinate) As Double
        'Internal function variable variables
        Dim Result As Double

        'Calculating Radius (= Result)
        Result = ((Point.X - Referencepoint.X) ^ 2 + (Point.Y - Referencepoint.Y) ^ 2) ^ 0.5

        'Returning function value
        Return Result

    End Function

    'Function calculates the sinus between two points
    Function CreateSinus(Point As Coordinate, Referencepoint As Coordinate) As Double
        'Internal function variables
        Dim Result As Double
        Dim Radius As Double

        'Calculating Radius and Sinus (= Result)
        Radius = ((Point.X - Referencepoint.X) ^ 2 + (Point.Y - Referencepoint.Y) ^ 2) ^ 0.5
        Result = (Point.Y - Referencepoint.Y) / Radius

        'Returning function value
        Return Result

    End Function

    'Function calculates the cosinus between two points
    Function CreateCosinus(Point As Coordinate, Referencepoint As Coordinate) As Double
        'Internal function variables
        Dim Result As Double
        Dim Radius As Double

        'Calculating Radius and Cosinus (= Result)
        Radius = ((Point.X - Referencepoint.X) ^ 2 + (Point.Y - Referencepoint.Y) ^ 2) ^ 0.5
        Result = (Point.X - Referencepoint.X) / Radius

        'Returning function value
        Return Result

    End Function

    'Function calculates the arc in degrees between two points
    Function CreateDegree(Point As Coordinate, Referencepoint As Coordinate) As Double
        'Internal function variables
        Dim Result As Double
        Dim Radius As Double
        Dim Sinus As Double
        Dim Cosinus As Double
        Dim TempArc As Double

        'Calculating Radius, Sinus and Cosinus
        Radius = ((Point.X - Referencepoint.X) ^ 2 + (Point.Y - Referencepoint.Y) ^ 2) ^ 0.5
        Sinus = (Point.Y - Referencepoint.Y) / Radius
        Cosinus = (Point.X - Referencepoint.X) / Radius

        'Calculating TempArc in degree
        TempArc = Math.Acos(Cosinus) * (180 / Math.PI)

        'Determining the real arc (=Result) based on Sinus and Cosinus in degree
        If Cosinus >= 0 And Sinus < 0 Then
            Result = 90 - TempArc
        ElseIf Cosinus >= 0 And Sinus >= 0 Then
            Result = 90 + TempArc
        ElseIf Cosinus < 0 And Sinus >= 0 Then
            Result = 90 + TempArc
        ElseIf Cosinus < 0 And Sinus < 0 Then
            Result = 450 - TempArc
        End If

        'Returning function value
        Return Result

    End Function

    'Function calculates polar coordinate between two points
    Function CreatePolarCoord(Point As Coordinate, Referencepoint As Coordinate) As PolarCoordinate
        'Internal function variable variables
        Dim TempArc As Double
        Dim Result As PolarCoordinate

        'Calculating Radius, Cosinus, Sinus and Arc
        Result.Radius = ((Point.X - Referencepoint.X) ^ 2 + (Point.Y - Referencepoint.Y) ^ 2) ^ 0.5
        Result.Cosinus = (Point.X - Referencepoint.X) / Result.Radius
        Result.Sinus = (Point.Y - Referencepoint.Y) / Result.Radius

        'Calculating TempArc in degrees
        TempArc = Math.Acos(Result.Cosinus) * (180 / Math.PI)

        'Determining the real arc (=Result.Arc) based on Sinus and Cosinus in degree
        If Result.Cosinus >= 0 And Result.Sinus < 0 Then
            Result.Arc = 90 - TempArc
        ElseIf Result.Cosinus >= 0 And Result.Sinus >= 0 Then
            Result.Arc = 90 + TempArc
        ElseIf Result.Cosinus < 0 And Result.Sinus >= 0 Then
            Result.Arc = 90 + TempArc
        ElseIf Result.Cosinus < 0 And Result.Sinus < 0 Then
            Result.Arc = 450 - TempArc
        End If

        'Returning function value
        Return Result

    End Function

    'Part 3: Form loading activities

    Private Sub SBPmain_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        'On load the text or image for the buttons is created (Text is horizontal an vertical centered )
        'Subroutine internal variables
        Dim ButtonText As String
        Dim EndOfLine As String = Chr(13) & Chr(10)

        'Creating the text for SmartButton01
        ButtonText = "Top" & EndOfLine & EndOfLine & EndOfLine & EndOfLine &
            "Left         Center         Right" &
             EndOfLine & EndOfLine & EndOfLine & EndOfLine & "Bottom"
        SmartButton01.Text = ButtonText

        'Creating the text for SmartButton02
        ButtonText = "1    2    3" & EndOfLine & EndOfLine &
            "4    5    6" & EndOfLine & EndOfLine &
            "7    8    9" & EndOfLine & EndOfLine &
            "Cl   0   Bs"
        SmartButton02.Text = ButtonText

        'Image used for SmartButton03
        'Saving a copy of the original picture
        BaseImage = Button03PictureBox.Image.Clone

    End Sub

    'Part 4: Handling clicks on SmartButton01
    Private Sub SmartButton01_Click(sender As Object, e As EventArgs) Handles SmartButton01.Click

        'Determinating positioon of mouse click

        'Mouse position on screen
        Dim ScreenMouse As Coordinate
        ScreenMouse.X = MousePosition.X
        ScreenMouse.Y = MousePosition.Y

        'Form topleftcorner on screen
        Dim FormTopLeftCorner As Coordinate
        FormTopLeftCorner.X = Me.Left
        FormTopLeftCorner.Y = Me.Top

        'Forms border- and barsize are calculated by using the function Frame
        Dim FormFrame As FrameSize
        FormFrame = Frame(Me)

        'Position topleftcorner of button based on clientsize form
        Dim ButtonTopLeftCorner As Coordinate
        ButtonTopLeftCorner.X = SmartButton01.Left
        ButtonTopLeftCorner.Y = SmartButton01.Top

        'Position mouse on SmartButton
        Dim ButtonMouse As Coordinate
        'Calculate relative position mouse on the SmartButton
        ButtonMouse.X = ScreenMouse.X - FormTopLeftCorner.X - FormFrame.Border - ButtonTopLeftCorner.X
        ButtonMouse.Y = ScreenMouse.Y - FormTopLeftCorner.Y - FormFrame.Border - FormFrame.Bar - ButtonTopLeftCorner.Y

        'Data to labels on form
        XposMouse01Value.Text = ButtonMouse.X
        YposMouse01Value.Text = ButtonMouse.Y

        'Calculating center of SmartButton01
        Dim Center As Coordinate
        Center.X = SmartButton01.Width / 2
        Center.Y = SmartButton01.Height / 2

        'Data to labels on form
        XposCenterValue.Text = Center.X
        YposCenterValue.Text = Center.Y

        'To discreminate Top/Bottom/Left/Right of the mouseposition the mouse sinus and cosinus 
        'will be compared with the sinus and cosinus of the topleftcormer of the button (CheckPoint/CheckVector)

        'Setting CheckPoint data
        Dim CheckPoint As Coordinate
        Dim CheckVector As PolarCoordinate
        CheckPoint.X = 0
        CheckPoint.Y = 0
        'Calculating data for CheckVector
        CheckVector = CreatePolarCoord(CheckPoint, Center)

        'Data to labels on form
        XposCheckValue.Text = CheckPoint.X
        YposCheckValue.Text = CheckPoint.Y
        RadiusCheckVectorValue.Text = CheckVector.Radius
        CosinusCheckVectorValue.Text = CheckVector.Cosinus
        SinusCheckVectorValue.Text = CheckVector.Sinus
        ArcCheckVectorValue.Text = CheckVector.Arc

        'Calculate PolarCoordinate MouseVector
        Dim MouseVector As PolarCoordinate
        MouseVector = CreatePolarCoord(ButtonMouse, Center)

        'Data to the labels on the form
        RadiusMouseVector01Value.Text = MouseVector.Radius
        CosinusMouseVector01Value.Text = MouseVector.Cosinus
        SinusMouseVector01Value.Text = MouseVector.Sinus
        ArcMouseVector01Value.Text = MouseVector.Arc

        'Creating 5 zones and adding functionality to those zones

        'If Mouse position within a radius of 20% of the CheckVector > Center
        If MouseVector.Radius < CheckVector.Radius / 5 Then
            Button01ResultValue.Text = "Center"

            'Comparing sinus and cosinus values for determinating Top/Bottom/Left/Right

        ElseIf MouseVector.Sinus < CheckVector.Sinus Then
            Button01ResultValue.Text = "Top"

        ElseIf MouseVector.Sinus > -CheckVector.Sinus Then
            Button01ResultValue.Text = "Bottom"

        ElseIf MouseVector.Cosinus < -CheckVector.Cosinus Then
            Button01ResultValue.Text = "Left"

        ElseIf MouseVector.Cosinus > CheckVector.Cosinus Then
            Button01ResultValue.Text = "Right"

        Else
            'For the most increadible cases (if cases above don't fit)
            Button01ResultValue.Text = "Nothing"
        End If

    End Sub

    'Part 5: Handling clicks on SmartButton02
    Private Sub SmartButton02_Click(sender As Object, e As EventArgs) Handles SmartButton02.Click

        'Determinating positioon of mouse click

        'Mouse position on screen
        Dim ScreenMouse As Coordinate
        ScreenMouse.X = MousePosition.X
        ScreenMouse.Y = MousePosition.Y

        'Form topleftcorner on screen
        Dim FormTopLeftCorner As Coordinate
        FormTopLeftCorner.X = Me.Left
        FormTopLeftCorner.Y = Me.Top

        'Forms border- and barsize are calculated by using the function Frame
        Dim FormFrame As FrameSize
        FormFrame = Frame(Me)

        'Position topleftcorner of button based on clientsize form
        Dim ButtonTopLeftCorner As Coordinate
        ButtonTopLeftCorner.X = SmartButton02.Left
        ButtonTopLeftCorner.Y = SmartButton02.Top

        'Position mouse on SmartButton
        Dim ButtonMouse As Coordinate
        'Calculate relative position mouse on the SmartButton
        ButtonMouse.X = ScreenMouse.X - FormTopLeftCorner.X - FormFrame.Border - ButtonTopLeftCorner.X
        ButtonMouse.Y = ScreenMouse.Y - FormTopLeftCorner.Y - FormFrame.Border - FormFrame.Bar - ButtonTopLeftCorner.Y

        'Data to labels on form
        XposMouse02Value.Text = ButtonMouse.X
        YposMouse02Value.Text = ButtonMouse.Y

        'Adding functionality to zones on SmartButton02 (adding characters to SmartText)

        'Vertical borders at (X=) 40 and 80
        'Horizontal borders a (Y=) 30, 60 and 90
        Select Case ButtonMouse.X
            Case 0 To 39
                Select Case ButtonMouse.Y
                    Case 0 To 29
                        SmartText = SmartText + "1"
                    Case 30 To 59
                        SmartText = SmartText + "4"
                    Case 60 To 89
                        SmartText = SmartText + "7"
                    Case 90 To 119
                        'Deleting all text
                        SmartText = ""
                End Select
            Case 40 To 79
                Select Case ButtonMouse.Y
                    Case 0 To 29
                        SmartText = SmartText + "2"
                    Case 30 To 59
                        SmartText = SmartText + "5"
                    Case 60 To 89
                        SmartText = SmartText + "8"
                    Case 90 To 119
                        SmartText = SmartText + "0"
                End Select
            Case 80 To 119
                Select Case ButtonMouse.Y
                    Case 0 To 29
                        SmartText = SmartText + "3"
                    Case 30 To 59
                        SmartText = SmartText + "6"
                    Case 60 To 89
                        SmartText = SmartText + "9"
                    Case 90 To 119
                        'Deleting last characters (only if Smart <> "")
                        If SmartText <> "" Then
                            SmartText = Mid(SmartText, 1, Len(SmartText) - 1)
                        End If
                End Select
        End Select

        'Smarttect to label on form
        Button02ResultValue.Text = SmartText
    End Sub

    'Part 6: Handling clicks on SmartButton03

    Private Sub SmartButton03_Click(sender As Object, e As EventArgs) Handles SmartButton03.Click
        'Subroutine internal variable
        Dim TempImage As Bitmap

        'Determinating positioon of mouse click

        'Mouse position on screen
        Dim ScreenMouse As Coordinate
        ScreenMouse.X = MousePosition.X
        ScreenMouse.Y = MousePosition.Y

        'Form topleftcorner on screen
        Dim FormTopLeftCorner As Coordinate
        FormTopLeftCorner.X = Me.Left
        FormTopLeftCorner.Y = Me.Top

        'Forms border- and barsize are calculated by using the function Frame
        Dim FormFrame As FrameSize
        FormFrame = Frame(Me)

        'Position topleftcorner of button based on clientsize form
        Dim ButtonTopLeftCorner As Coordinate
        ButtonTopLeftCorner.X = SmartButton03.Left
        ButtonTopLeftCorner.Y = SmartButton03.Top

        'Position mouse on SmartButton
        Dim ButtonMouse As Coordinate
        'Calculate relative position mouse on the SmartButton
        ButtonMouse.X = ScreenMouse.X - FormTopLeftCorner.X - FormFrame.Border - ButtonTopLeftCorner.X
        ButtonMouse.Y = ScreenMouse.Y - FormTopLeftCorner.Y - FormFrame.Border - FormFrame.Bar - ButtonTopLeftCorner.Y

        'Data to labels on form
        XposMouse03Value.Text = ButtonMouse.X
        YposMouse03Value.Text = ButtonMouse.Y

        'Calculating center of SmartButton03
        Dim Center As Coordinate
        Center.X = SmartButton03.Width / 2
        Center.Y = SmartButton03.Height / 2

        'To discreminate Top/Bottom/Left/Right of the mouseposition the mouse Arc will be used

        'Calculate PolarCoordinate MouseVector
        Dim MouseVector As PolarCoordinate
        MouseVector = CreatePolarCoord(ButtonMouse, Center)

        'Data to the label on the form
        ArcMouseVector03Value.Text = MouseVector.Arc

        'Discriminating 4 zones of 90 degree 
        If MouseVector.Arc >= 315 Or MouseVector.Arc < 45 Then          'Top zone
            'Data to label on form
            Button03ResultValue.Text = "Top, Reset image"
            'Loading the original picture
            Button03PictureBox.Image = BaseImage.Clone

        ElseIf MouseVector.Arc >= 45 And MouseVector.Arc < 135 Then     'Right zone
            'Data to label on form
            Button03ResultValue.Text = "Right, Turn image 90 degree clockwise"
            'Turning image 90 degree
            TempImage = CType(Button03PictureBox.Image, Bitmap)
            TempImage.RotateFlip(RotateFlipType.Rotate90FlipNone)
            Button03PictureBox.Image = TempImage

        ElseIf MouseVector.Arc >= 135 And MouseVector.Arc < 225 Then    'Bottom zone
            'Data to label on form
            Button03ResultValue.Text = "Bottom, Turn image 180 degree"
            'Turning image 180 degree
            TempImage = CType(Button03PictureBox.Image, Bitmap)
            TempImage.RotateFlip(RotateFlipType.Rotate180FlipNone)
            Button03PictureBox.Image = TempImage

        ElseIf MouseVector.Arc >= 225 And MouseVector.Arc < 315 Then    'Left zone
            'Data to label on form
            Button03ResultValue.Text = "Left, Turn image 90 degree anti-clockwise"
            'Turning image 270 degree (= -90 degree)
            TempImage = CType(Button03PictureBox.Image, Bitmap)
            TempImage.RotateFlip(RotateFlipType.Rotate270FlipNone)
            Button03PictureBox.Image = TempImage

        End If

    End Sub

End Class
